Subject: Re: [PATCH 2.6.20-rc3]: 8139cp: Don't blindly enable interrupts

From: Jeff Garzik <[email-masked]>
Date: Thu, 18 Jan 2007 11:48:21 -0500

Chris Lalancette wrote:
> Francois Romieu wrote:
> 
>> Chris Lalancette <[email-masked]> :
>> [...]
>>  
>>
>>>     Thanks for the comments.  While the patch you sent will help, there are
>>> still other places that will have problems.  For example, in netpoll_send_skb,
>>> we call local_irq_save(flags), then call dev->hard_start_xmit(), and then call
>>> local_irq_restore(flags).  This is a similar situation to what I described
>>> above; we will re-enable interrupts in cp_start_xmit(), when netpoll_send_skb
>>> doesn't expect that, and will probably run into issues.
>>>     Is there a problem with changing cp_start_xmit to use the
>>> spin_lock_irqsave(), besides the extra instructions it needs?
>>>    
>>>
>> No. Given the history of locking in netpoll and the content of
>> Documentation/networking/netdevices.txt, asking Herbert which rule(s)
>> the code is supposed to follow seemed safer to me.
>>
>> You can forget my patch.
>>
>> Please resend your patch inlined to Jeff as described in
>> http://linux.yyz.us/patch-format.html.
>>
>>  
>>
> Francois,
>      Great.  Resending mail, shortening subject to < 65 characters and
> inlining the patch.
> 
> Thanks,
> Chris Lalancette
> 
> Similar to this commit:
> 
> http://kernel.org/git/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commitdiff;h=d15e9c4d9a75702b30e00cdf95c71c88e3f3f51e
> 
> It's not safe in cp_start_xmit to blindly call spin_lock_irq and then
> spin_unlock_irq, since it may very well be the case that cp_start_xmit
> was called with interrupts already disabled (I came across this bug in
> the context of netdump in RedHat kernels, but the same issue holds, for
> example, in netconsole). Therefore, replace all instances of
> spin_lock_irq and spin_unlock_irq with spin_lock_irqsave and
> spin_unlock_irqrestore, respectively, in cp_start_xmit(). I tested this
> against a fully-virtualized Xen guest using netdump, which happens to
> use the 8139cp driver to talk to the emulated hardware. I don't have a
> real piece of 8139cp hardware to test on, so someone else will have to
> do that.
> 
> Signed-off-by: Chris Lalancette <[email-masked]>

applied.

In the future, please remove the quoted emails stuff, and anything else 
that does not belong in the kernel changelog.  It must be hand-edited 
out, before using git-am to merge your patch into the kernel tree.

	Jeff